{ stdenv, rustPlatform, cacert, git, cargo-vendor }:

with rustPlatform;
let
  sha256 = "19cdc0lkm9247n6kf23ki66gysz530j1x2lfnzq7n0cpcs53q3h3";
  fetchcargo = import ./fetchcargo.nix {
    inherit stdenv cacert git cargo-vendor;
    inherit (rust) cargo;
  };
  tnetplugDeps = fetchcargo {
    name = "tnetplug";
    src = ../.;
    inherit sha256;
  };
in

buildRustPackage rec {
  name = "tnetplug";
  version = "0.0.0";

  src = ../.;
  cargoSha256 = sha256;

  buildInputs = [ tnetplugDeps ];
  patchPhase = ''
    cat >> .cargo/config <<EOF
    [source.crates-io]
    replace-with = "vendored-sources"

    [source.vendored-sources]
    directory = "${tnetplugDeps}"
    EOF
  '';

  buildPhase = ''
    export CARGO_HOME=$(mktemp -d cargo-home.XXX)
    cargo build --release
  '';

  doCheck = false;
  installPhase = ''
    mkdir -p $out/lib
    cp target/thumbv7em-none-eabihf/release/tnetplug $out/lib/
  '';
}
